Subject: Re: bug#43384: guix pull: backtrace "no route to host"

From: Chris Marusich <[email-masked]>
Date: Tue, 04 May 2021 18:56:02 -0700

Jan Wielkiewicz <[email-masked]> writes:

> Hello, 
> I tried running "guix pull" but it gave me a backtrace.
>
> guix substitute: error: connect: No route to host
> @ substituter-failed
> /gnu/store/c4mzhay8jrg5r43wkn4f9004afvly0ad-po4a-0.57 256 fetching path
> `/gnu/store/c4mzhay8jrg5r43wkn4f9004afvly0ad-po4a-0.57' failed with
> exit code 1 @ substituter-started
> /gnu/store/s6ha2sssblw06sjpw4zawzx98zwbj5m7-graphviz-2.42.3 substitute
> killing process 6694 Backtrace: 11 (primitive-load
> "/gnu/store/lardz9zqi5ypgrdrj6dyfgj9p3bca2ab-compute-guix-derivation")
> In ice-9/eval.scm: 155:9 10 (_ _) 159:9  9 (_
> #(#(#(#(#(#(#(#(#(#(#(#(#(#<directory (guile-user) 7fe2f2ca4f?> ?) ?)
> ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?)) In ./guix/store.scm: 2042:24  8
> (run-with-store #<store-connection 256.99 7fe2f10265f0> _
> #:guile-for-build _ #:system _ #:target _) 1876:8  7 (_ _) In
> ./guix/gexp.scm: 244:18  6 (_ _)
>    1064:2  5 (_ _)
>     924:2  4 (_ _)
>     785:4  3 (_ _)
> In ./guix/store.scm:
>   1924:12  2 (_ #<store-connection 256.99 7fe2f10265f0>)
>    1357:5  1 (map/accumulate-builds #<store-connection 256.99
> 7fe2f10265f0> _ _) 1368:15  0 (_ #<store-connection 256.99
> 7fe2f10265f0> 7fe2f10265f0> _ _)
>
> ./guix/store.scm:1368:15: ERROR:
>   1. &store-protocol-error:
>       message: "some substitutes for the outputs of derivation
> `/gnu/store/bxw2dzjmdrq7qmv0w1mpzqrkfqs9p7q2-po4a-0.57.drv' failed
> (usually happens due to networking issues); try `--fallback' to build
> derivation from source " status: 1 guix pull: error: You found a bug:
> the program
> '/gnu/store/lardz9zqi5ypgrdrj6dyfgj9p3bca2ab-compute-guix-derivation'
> failed to compute the derivation for Guix (version:
> "71992a532dd0bb88b39dda285482b332a24dae66"; system: "x86_64-linux";
> host version: "1192ae940434808560b3170107e4ce44855816c3"; pull-version:
> 1). Please report it by email to <[email-masked]>.
>
>
> Jan Wielkiewicz

It sounds like perhaps this error was caused by a networking error.
Although much time has passed since you opened this bug report, I think
in situations like this, you can work around the issue by trying the
command with the --fallback option, as the error message suggests.  Did
you try that?

You could try something like this:

  guix pull --fallback

You could also try building just that one problematic derivation with
fallback, like this:

  guix build --fallback /gnu/store/bxw2dzjmdrq7qmv0w1mpzqrkfqs9p7q2-po4a-0.57.drv

If successful, you can then retry "guix pull" without the --fallback
option, but if a network error was the cause, the same kind of issue
might happen again for any other derivation.  Therefore, I would
recommend trying "guix pull --fallback" if this sort of problem happens
frequently for you.

FYI, you can also add "--fallback" to various commands, like "guix
build" and "guix package".

-- 
Chris